;ScreenFocus (Contributor : falsam, Gally, Crisot)
;PB 5.30 -> 5.40
;Licence As you like
;
; Permet de dplacer la souris en dehors d'un OpenWindowedScreen() quand elle est captive
;

Declare ScreenFocus(win, x1, y1, x2, y2)

Global x.f, y.f, z.f

UsePNGImageDecoder()

Enumeration Font
  #FontGlobal  
EndEnumeration

Enumeration Window
  #Mainform
EndEnumeration

Enumeration Gadget
  #Entity
  #EntityXYZ
EndEnumeration

;- Init Window
LoadFont(#FontGlobal, "", 11)
SetGadgetFont(#PB_Default, FontID(#FontGlobal))
OpenWindow(#Mainform, 0, 0, 1000, 700, "Screen Focus", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
TextGadget(#PB_Any, 10, 15, 50, 22, "Entit")
StringGadget(#Entity, 60, 10, 100, 24, "?", #PB_String_ReadOnly)

TextGadget(#PB_Any, 180, 15, 50, 22, "Picking")
StringGadget(#EntityXYZ, 230, 10, 150, 24, "0, 0, 0", #PB_String_ReadOnly)

TextGadget(#PB_Any, 100, 620, 800, 22, "Select a point with the mouse and press the space key to create a cube - Esc : Exit")

FrameGadget(#PB_Any, 90, 80, 820, 530, "Your OpenWindowedScreen")
;- Init 3D
InitEngine3D() : InitKeyboard() : InitSprite() : InitMouse()

OpenWindowedScreen(WindowID(0), 100, 100, 800, 500)
Add3DArchive(#PB_Compiler_Home + "Examples/3D/Data/Textures", #PB_3DArchive_FileSystem)

;Light & Shadow
AmbientColor(RGB(127, 127, 127))
CreateLight(#PB_Any,RGB(151, 251, 151), 50, 500, 500)
WorldShadows(#PB_Shadow_Additive)

;Camera
CreateCamera(0, 0, 0,100,100)
CameraBackColor(0, RGB(145, 182, 201))
MoveCamera(0, 0, 5, 10, #PB_Absolute)  
CameraLookAt(0, 0,0,0)   

;Material
CreateMaterial(0, TextureID(LoadTexture(#PB_Any, "Dirt.jpg")))      ;Ground Texture
CreateMaterial(1, TextureID(LoadTexture(#PB_Any, "MRAMOR6X6.jpg"))) ;Cube Texture

;Ground
CreateEntity(-1, MeshID(CreatePlane(-1, 20, 20, 1, 1, 10, 10)), MaterialID(0))

;Create Model 
Model = CreateEntity(-1,MeshID(CreateCube(-1, 1)), MaterialID(1), 0, 0.5, 0)

;Load Sprite (2D)
Pointer2D = LoadSprite(-1, "mousepointerred.png")

Repeat
  Repeat  ;Window Events
    Event = WindowEvent()
    
    Select Event    
      Case #PB_Event_CloseWindow
        End
    EndSelect  
  Until Event=0
  
  If ExamineKeyboard()
    If KeyboardPushed (#PB_Key_Escape)
      Break
    EndIf
  
    If KeyboardReleased (#PB_Key_Space)
      CreateEntity(-1,MeshID(CreateCube(-1, 1)), MaterialID(1), x, y+0.5, z)
    EndIf
  EndIf
  
  ;Picking
  ExamineMouse()
  If MouseButton(#PB_MouseButton_Left)             
    Result = MousePick(Camera, MouseX(), MouseY())
    x = PickX()
    y = PickY()
    z = PickZ()
        
    If Result <>  -1
      SetGadgetText(#Entity, Str(Result))
      SetGadgetText(#EntityXYZ, StrF(x, 2) + ", " + StrF(y, 2) + ", " + StrF(z, 2))
    Else
      SetGadgetText(#Entity, "?")
      SetGadgetText(#EntityXYZ, "0, 0, 0")
    EndIf
  EndIf
  
  RenderWorld(40)
  
  ;ScreenFocus : Affichage du sprite reprsentant la souris
  If ScreenFocus(#MainForm, 100, 100, 100, 100)
    DisplayTransparentSprite(Pointer2D, MouseX(), MouseY())
  EndIf    
  
  FlipBuffers()  
ForEver

Procedure ScreenFocus(Window, Left, Top, RightOffset, BottomOffset)
  If IsScreenActive()
    Protected X = WindowMouseX(Window) 
    Protected Y = WindowMouseY(Window)
    Protected Value.b = Bool(X>Left And Y>Top And X<WindowWidth(Window)-RightOffset-1 And Y<WindowHeight(Window)-BottomOffset-1)
  
    ReleaseMouse(1 - Value)
    MouseLocate(X-Left, Y-Top)
  
    ProcedureReturn Value
  EndIf 
EndProcedure
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 64
; FirstLine = 30
; Folding = --
; EnableXP